#include <stdlib.h>
#include <string.h>

struct list {
    int len;
    char const *str;
    struct list *next;
};

struct list *append_list(struct list *l, char const *str)
{
    struct list *node = malloc(sizeof *l);
/* Bug #2: Oublié de gérer le cas où str est NULL */
//    node->len = str ? strlen(str) : 0;
    node->len = strlen(str);
    node->str = str;
    node->next = NULL;

/* Bug #1: Oublié de tester si la liste est vide */
//    if(l == NULL)
//        return node;

    struct list *last = l;
    while(last->next != NULL)
        last = last->next;
    last->next = node;
    return l;
}

void free_list(struct list *l)
{
/* Bug #3: Oublié de libérer tous reste des éléments */
    free(l);
//    while(l != NULL) {
//        free(l);
//        l = l->next;
//    }

/* Bug #4; Accès à l->next après le free */
//    while(l != NULL) {
//        struct list *next = l->next;
//        free(l);
//        l = next;
//    }
}

int main(void)
{
    struct list *l = NULL;
    l = append_list(l, "Hello gdb!");
    l = append_list(l, "*sniping intensifies*");
    l = append_list(l, NULL);
    free_list(l);
    return 0;
}
